import {
  get, post,
} from '../../utils/http';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfo: {},
    visible: false,
    genders: ["男","女"],
    genderIndex: 0,
    date: '2016-09-01',
    region: ['广东省', '广州市', '海珠区'],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    if(options.userId) {
      this.setData({
        userId: options.userId
      },() => {
        // this.getUserInfo()
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // this.getUserFiles()
    this.getUserInfo()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    this.setData({
      visible: false
    })
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  isShow() {},

  /**
   * 弹框状态
   */
  onPopupState(e, key, value) {
    if (e) {
      key = e.currentTarget.dataset.key
      value = e.currentTarget.dataset.value
    }
    console.log(key)
    console.log(value)
    this.setData({
      [key]: value
    })
  },

  /**
   * 选择性别
  */
  bindGenderChange(e) {
    this.setData({
      ['userInfo.sex']: Number(e.detail.value) + 1,
    },() => {
      this.setUserFiles()
    })
  },

  /**
   * 选择生日
  */
  bindDateChange: function(e) {
    console.log(e)
    this.setData({
      ['userInfo.birthday']: e.detail.value,
      // date: e.detail.value
    },() => {
      this.setUserFiles()
    })
  },

  /**
   * 选择所在地
  */
  bindRegionChange: function (e) {
    this.setData({
      region: e.detail.value,
      ['userInfo.city']: e.detail.value.toString(),
    },() => {
      this.setUserFiles()
    })
  },

  /**
   * 获取用户档案
   * api/user/files
  */
  getUserFiles() {
    get('api/user/files',{},(res) => {
      this.setData({
        userInfo: res.data
      })
      console.log(res)
    })
  },

  /**
   * 更新用户档案
   * api/user/save_files
  */
  setUserFiles() {
    let { user_id,avatar_url,nickname,realname,sex,birthday,mobile,city,tags } = this.data.userInfo;
    post('api/user/update',{
      user_id,
      avatar_url,
      nickname,
      realname,
      sex,
      birthday,
      mobile,
      city,
      tags
    },() => {

    })
  },

  /**
   * 获取用户信息
   * api/user/info
  */
  getUserInfo() {
    let { userId } = this.data;
    get('api/user/info',{
      user_id: userId
    },(res) => {
      this.setData({
        userInfo: res.data
      })
      console.log(res)
    })
  },
  
})