import { get } from "../../utils/http"

// pages/historyOrder/historyOrder.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    total: 0,
    page: 1,
    user_id: '',
    detail: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    if(options.user_id) {
      this.setData({
        user_id: options.user_id,
        detail: JSON.parse(options.detail)
      },() => {
        this.getHistoryOrder()
      })
    }
    
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if(this.data.page * 10 < this.data.total) {
      this.getHistoryOrder(++this.data.page)
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  /**
   * 获取历史订单
   * api/order/history
  */
  getHistoryOrder() {
    let { page,list,user_id,detail } = this.data;
    let month = detail.month
    let date = detail.date
    get('api/order/history',{
      user_id,
      day: `${detail.year}-${month < 10 ? '0'+month : month}-${date < 10 ? '0'+date : date}`,
      page,
      limit: 10
    },(res) => {
      list.push(...res.data.list)
      this.setData({ list,total: res.data.total, })
    })
  }
})