import {
  get,
  post
} from '../../utils/http';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    current: 0,
    currentDay: '2021-11-29',
    startDay: '1998-04-20',
    endDay: '2021-11-29',
    homeData: {},
    list: [],
    total: 0,
    page: 1,
    // 状态，1待进行，2进行中，3已完成
    status: {
      1: '待进行',
      2: '进行中',
      3: '已完成',
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let date = new Date()
    let year = date.getFullYear()
    let month = date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1
    let day = date.getDate() < 10 ? '0'+date.getDate() : date.getDate()
    console.log(year,month,day)
    this.setData({
      currentDay: `${year}-${month}-${day}`,
      startDay: `${year}-${month}-${day}`,
      endDay: `${year}-${month}-${day}`,
    })
    this.getHomeData();
    this.getOrderList();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if(this.data.page * 10 < this.data.total) {
      this.getOrderList(++this.data.page)
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  /**
   * 切换状态
  */
  onTabsChange(e) {
    let current = e.currentTarget.dataset.id
    let startDay,endDay,currentDay
    if(current == this.data.current) {
      return;
    }
    if(current == 0) {
      startDay = this.formData(0)
      endDay = this.formData(0)
      currentDay = this.formData(0)
    } else if(current == 1) {
      startDay = this.formData(0)
      endDay = this.formData(7)
      currentDay = this.formData(0)
    } else {
      startDay = this.formData(-7)
      currentDay = this.formData(-7)
      endDay = this.formData(0)
    }
    this.setData({
      current,
      page: 1,
      startDay,endDay,currentDay
    },() => {
      this.getOrderList(1)
    })
  },

  /**
   * 选择时间
  */
  bindDateChange: function(e) {
    console.log('picker发送选择改变，携带值为', e.detail.value)
    this.setData({
      [e.currentTarget.dataset.date]: e.detail.value,
    })
  },

  /**
   * 订单搜索
  */
  onSearchOrder() {
    this.getOrderList();
  },

  /**
   * 获取首页统计数据
  */
  getHomeData() {
    get('api/home',{},(res) => {
      this.setData({
        homeData: res.data
      })
    })
  },

  /**
   * 首页订单列表
  */
  getOrderList(_page) {
    let { list,current,page,startDay,endDay } = this.data;
    get('api/order/list',{
      start_day: startDay,
      end_day: endDay,
      type: current,
      page: _page || page,
      limit: 10
    },(res) => {
      if (_page == 1 || page == 1) {
        list = []
        this.data.page = 1
      }
      list.push(...res.data.list)
      this.setData({
        list,
        total: res.data.total,
        spinning: false
      })
      console.log(res)
    })
  },

  /**'
   * 格式化时间
  */
  formData(_day) {
    let date = new Date()
    date=date.setDate(date.getDate()+_day);
    date=new Date(date);
    let year = date.getFullYear()
    let month = date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1
    let day = date.getDate() < 10 ? '0'+date.getDate() : date.getDate()
    console.log(year,month,day)
    return `${year}-${month}-${day}`;
  },

  /**
   * 跳转客户信息
  */
  goToClientInfo(e) {
    console.log(e)
    // return;
    wx.navigateTo({
      url: `/pages/clientInfo/clientInfo?userId=${e.currentTarget.dataset.userid}&orderId=${e.currentTarget.dataset.orderid}`,
    })
  },

  /**
   * 跳转客户信息
  */
  goToFeedback(e) {
    let item = e.currentTarget.dataset.item
    wx.navigateTo({
      url: `/pages/feedback/feedback?orderId=${ item.order_id }&cover=${ item.cover_url }&name=${ item.project_name }`,
    })
  }
})