import { get,post } from "../../utils/http"

// pages/tagsAdd/tagsAdd.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    tags:[],
    list: []
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    if(options.user_id) {
      this.setData({
        user_id: options.user_id
      },() => {
        this.getUserInfo()
        this.getUserTags()
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  /**
   * 选中标签
  */
  onChangeTags(e) {
    let status = e.currentTarget.dataset.status
    let index = e.currentTarget.dataset.index
    let { tags,list } = this.data;
    let sum = list.length
    let that = this;
    
    this.setData({
      ['tags[' + index + '].status']: !status
    },() => {
      tags.forEach((item) => {
        if(item.status) {
          sum ++
        }
      })
      if(sum > 10) {
        wx.showToast({
          title: '最多添加10个标签',
          icon: 'none'
        })
        that.setData({
          ['tags[' + index + '].status']: false
        })
      }
    })
  },

  /**
   * 获取用户信息
   * api/user/info
  */
  getUserInfo() {
    let { user_id } = this.data;
    get('api/user/info',{
      user_id
    },(res) => {
      console.log(res)
      this.setData({
        list: res.data.tags
      })
      console.log(res)
    })
  },

  /**
   * 获取常用标签
   * api/user/tags
  */
  getUserTags() {
    get('api/user/tags',{

    },(res) => {
      let { tags } = this.data;
      res.data.tags.forEach(item => {
        let obj = { tag:item,status:false }
        tags.push(obj)
        console.log(item)
      });
      this.setData({
        tags
      })
      console.log(res)
    })
  },

  /**
   * 添加标签
  */
  onSubmit() {
    let { user_id,list,tags } = this.data;
    tags.forEach((item,index) => {
      if(item.status) {
        list.push(item.tag)
      }
    })
    post('api/user/update',{
      user_id,
      tags: list.toString()
    },(res) => {
      wx.showToast({
        title: res.msg,
      })
      setTimeout(() => {
        wx.navigateBack()
      }, 1000);
      console.log(res)
    })
  }
})